#ifdef Dos
#include <dos.h>
#include <dir.h>
#endif

#include <stdlib.h>
#include <string.h>

#define bool uchar
#define true 1
#define false 0

#ifndef uchar
#define uchar unsigned char
#endif
#ifndef uint
#define uint unsigned int
#endif
#ifndef ulong
#define ulong unsigned long
#endif

inline void SendBits(uchar b)
{
  if(PORTTYPE==0)
    outportb(PORT+4, b & 3);
  else
    outportb(PORT, (b & 3));
}

inline uchar GetBits(void)
{
  uchar b;
  if(PORTTYPE==0)
  {
    b=(inportb(PORT+6) / 16) & 3;
    while(b!=((inportb(PORT+6)/16)&3))
    {
      b=(inportb(PORT+6)/16)&3;
#ifdef Dos
      if(kbhit())
        if(getch()==0x1B)
        {
          printf("\nUser break.\n");
          SendBits(0x3);
          if(f)
            fclose(f);
          exit(1);
        }
#endif
    }
    b=(inportb(PORT+6) / 16) & 3;
  }
  else
  { 
    b=((inportb(PORT+1)>>4)&0x03);
    while(b!=((inportb(PORT+1)>>4)&0x03))
      b=((inportb(PORT+1)>>4)&0x03);
  }
  return b;
}

uchar GetByte(void)
{
	uchar curbit, retval=0, tmpbyte;
  for(curbit=1;curbit!=0;curbit=curbit<<1)
  {
    while((tmpbyte=GetBits())==3)
#ifdef Dos
      if(kbhit())
        if(getch()==0x1B)
        {
          printf("\nUser break.\n");
          SendBits(0x3);
          if(f)
            fclose(f);
          exit(1);
        }
#endif
    if(tmpbyte==1)
    {
      retval+=curbit;
      SendBits(1);
      tmpbyte=2;
    }
    else
    {
      SendBits(2);
      tmpbyte=1;
    }
    while((GetBits()&tmpbyte)==0)
#ifdef Dos
      if(kbhit())
        if(getch()==0x1B)
        {
          printf("\nUser break.\n");
          SendBits(0x3);
          if(f)
            fclose(f);
          exit(1);
        }
#endif
    SendBits(3);
  }
	return retval;
}

void SendByte(uchar b)
{
	uchar curbit;
  for(curbit=1;curbit != 0;curbit=curbit<<1)
  {
    if((b & curbit) == 0)
    {
      SendBits(1);
      while((GetBits()&2) == 2)
      {
#ifdef Dos
        if(kbhit())
          if(getch()==0x1B)
          {
            printf("\nUser break.\n");
            SendBits(0x3);
            if(f)
              fclose(f);
            exit(1);
          }
#endif
      }
      SendBits(3);
      while((GetBits()&2) == 0)
      {
#ifdef Dos
        if(kbhit())
          if(getch()==0x1B)
          {
            printf("\nUser break.\n");
            SendBits(0x3);
            if(f)
              fclose(f);
            exit(1);
          }
#endif
      }
    }
    else
    {
      SendBits(2);
      while((GetBits()&1) == 1)
      {
#ifdef Dos
        if(kbhit())
          if(getch()==0x1B)
          {
            printf("\nUser break.\n");
            SendBits(0x03);
            if(f)
              fclose(f);
            exit(1);
          }
#endif
      }
      SendBits(3);
      while((GetBits()&1) == 0)
      {
#ifdef Dos
        if(kbhit())
          if(getch()==0x1B)
          {
            printf("\nUser break.\n");
            SendBits(0x3);
            if(f)
              fclose(f);
            exit(1);
          }
#endif
      }
    }
  }
}


void initport(void)
{
  if(PORTTYPE==0)
  {
#ifdef Linux
    if(ioperm(PORT+4, 1, 1) || ioperm(PORT+6, 1, 1))
      {
	printf("Cannot access specified port, aborting.\n");
	exit(1);
      }
#endif
    outportb(PORT+4, 0xf);
  }
  else
  {
#ifdef Linux
    if(ioperm(PORT, 1, 1) || ioperm(PORT+1, 1, 1))
      {
	printf("Cannot access specified port, aborting.\n");
	exit(1);
      }
#endif
    outportb(PORT, 0x03);
  }
}
